#include <sdsl/algorithms.hpp>
#include <sdsl/testutils.hpp>
#include <iostream>
#include <string>

using namespace sdsl;
using namespace std;

int main(){
	cout << "This program determines the number of runs in the psi-function of a text t." << endl;
	string file_name;
	do{
		file_name = "";
		cout << "Please enter the file name of the text to analyse or '-' to exit the program" << endl;
		cin >> file_name;
		char *text = NULL;
		uint64_t len;
		if( (len = file::readText(file_name.c_str() , text)) > 0 ){ // successfully read the file 
			int_vector<> sa(len, 0, bit_magic::l1BP(len)+1 ), psi;	
			algorithm::calculate_sa((unsigned char*)text, len, sa);	 // calculate suffix array
			algorithm::sa2psi(sa, psi); // calculate psi-function
			uint64_t long_runs = 0, one_diffs_in_psi = 0;
			bool in_run = false;
			for(uint64_t i=1; i<len; ++i){
				if( psi[i]>psi[i-1] and psi[i]==psi[i-1]+1 ){
					if(!in_run){
						in_run = true;
						++long_runs;
					}
					++one_diffs_in_psi;
				}else{
					in_run = false;
				}
			}
			cout << "number of long runs " << long_runs << endl;
			cout << "number of one differences in the long runs " << one_diffs_in_psi << endl;
		}
	}while( file_name != "-" );	


}
