#include "sdsl/range_minimum_support.hpp"
#include "sdsl/testutils.hpp"
#include "sdsl/util.hpp"
#include "sdsl/balanced_parentheses_support_sada.hpp"

#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>

using namespace sdsl;
using namespace std;

//typedef vector<int> tVI;
typedef int_vector<> tVI;

int main(){
	string file_name;
	cin>>file_name;
	int_vector<> v(100000000,0, 32);
	
	for(tVI::size_type i=0; i<v.size();++i){
		v[i] = rand()%(1ULL<<32);
	}
//	util::storeToFile(v, "/home/gog/sdsl/performance/test_cases/random_numbers_100000000.int_vector");
/*
	if( !util::loadFromFile(v, file_name.c_str()) ){
		cerr<<"# could not load file "<<file_name<<endl;		
		cerr<<"# exiting"<<endl;
		return 1;
	}
	std::cout<<file_name<<" ,";
*/
	tVI queries(1000000*2);
	for(tVI::size_type i=0; i<queries.size()/2; ++i){
		tVI::size_type l = rand()%v.size();
		tVI::size_type r = l + rand()%(v.size()-l);
		queries[2*i  ] = l;
		queries[2*i+1] = r;
	}

	stop_watch stopwatch;
	stopwatch.start();
	range_minimum_support_succinct_sct<tVI> rmq_sct(&v);
	stopwatch.stop();
	std::cerr<< stopwatch.getUserTime() << " ms for creation of rmq_sct"<< std::endl;
	std::cerr<<"constructed rmq_succint_sct"<<std::endl;
	{
		tVI dummy(0);
		v.swap(dummy);
	}
	std::cerr<<"free memory for v"<<std::endl;
//	range_minimum_support_succinct_sct<tVI, true, balanced_parentheses_support_sada<> > rmq_sct_sada(&v);
//	range_minimum_support_sparse_table<tVI> rmq_spt(&v);
//	typedef balanced_parentheses_support_sada<> bpss;
//	range_minimum_support_succinct_sada<tVI, true, balanced_parentheses_support_sada<> > rmq_sada(&v);

/*	std::cerr<<"Check correctness"<<std::endl;
	for(tVI::size_type i=0,l,r,m1,m2,m3,m4; i<1000000; ++i){
		l = queries[(2*i)%queries.size()];
		r = queries[(2*i+1)%queries.size()];
		
		m1 = rmq_sct(l, r);
		m2 = rmq_sct_sada(l, r);
	   	m3 = rmq_spt(l,r);	
		m4 = rmq_sada(l,r);

		if( m1!=m3 or m2!=m3 or m3!=m4 ){
			cout<<"m1="<<m1<<" m2="<<m2<<" m3="<<m3<<" m4="<<m4<<" l="<<l<<" r="<<r<<" v[m1]="<<v[m1]<<" v[m2]="<<v[m2]<<" v[m3]="<<v[m3]<<" v[m4]="<<v[m4]<<endl;
			break;
		}
	}
	for(tVI::size_type i=0; i<1000000; ++i){
		tVI::size_type l,r;
		l = rand() % rmq_sct.sct_bp.size();
		r = rand() % rmq_sct.sct_bp.size();
		if( l>r ) std::swap(l,r);
		tVI::size_type rmq1 = rmq_sct.sct_bp_support.rmq(l,r);
		tVI::size_type rmq2 = rmq_sct_sada.sct_bp_support.rmq(l,r);
		if( rmq_sct.sct_bp_support.excess(rmq1) != rmq_sct_sada.sct_bp_support.excess(rmq2) ){
			cout<<"rmq1="<<rmq1<<"  rmq2="<<rmq2<<" l="<<l<<" r="<<r<<std::endl;
			cout<<"excess(rmq1)="<<rmq_sct.sct_bp_support.excess(rmq1)<<" excess(rmq2)="<<rmq_sct_sada.sct_bp_support.excess(rmq2)<<std::endl;
			cout<<"bp[rmq1]="<<rmq_sct.sct_bp[rmq1]<<" bp[rmq2]="<<rmq_sct_sada.sct_bp[rmq2]<<std::endl;
			break;
		}
	}
*/	
/*	
	std::cout<< ((double)util::get_size_in_bytes(rmq_sct)*8)/rmq_sct.size() << ", ";
	
	tVI::size_type q=10000000;
	tVI::size_type k=0;
	stopwatch.start();
	for(tVI::size_type i=0,l,r; i<q; ++i){
		l = queries[(2*i)%queries.size()];
		r = queries[(2*i+1)%queries.size()];
		k+=rmq_sct(l, r);
	}
	stopwatch.stop();
	std::cerr<< stopwatch.getUserTime() << " ," << q << std::endl;
	std::cerr<<"# k="<<k<<std::endl;
*/	
}
