#include <sdsl/int_vector.hpp>
#include <iostream>

using namespace sdsl;
using namespace std;

int main(){
	int_vector<0> v(3);
	// set all elements to a large constant
	for(int_vector<0>::size_type i=0; i<v.size(); ++i)
		v[i] = 0xFFFF00000000FFFFULL;
	cout << "v.size() = " << v.size() << endl;
	for(int_vector<0>::size_type i=0; i<v.size(); ++i)
		cout << " v[" << i << "] = " << v[i] << endl;
	cout << endl;
	// now set int width to 32
	v.setIntWidth(32);
	cout << "v.size() = " << v.size() << endl;
	for(int_vector<0>::size_type i=0; i<v.size(); ++i)
		cout << " v[" << i << "] = " << v[i] << endl;
	cout << endl;
	// now set int width to 16
	v.setIntWidth(16);
	cout << "v.size() = " << v.size() << endl;
	for(int_vector<0>::size_type i=0; i<v.size(); ++i)
		cout << " v[" << i << "] = " << v[i] << endl;
	cout << endl;
}

/*
Output:
 
v.size() = 3
 v[0] = 18446462598732906495
 v[1] = 18446462598732906495
 v[2] = 18446462598732906495

v.size() = 6
 v[0] = 65535
 v[1] = 4294901760
 v[2] = 65535
 v[3] = 4294901760
 v[4] = 65535
 v[5] = 4294901760

v.size() = 12
 v[0] = 65535
 v[1] = 0
 v[2] = 0
 v[3] = 65535
 v[4] = 65535
 v[5] = 0
 v[6] = 0
 v[7] = 65535
 v[8] = 65535
 v[9] = 0
 v[10] = 0
 v[11] = 65535

*/
