#include "sdsl/wavelet_tree.hpp"
#include "sdsl/util.hpp"
#include <iostream>
#include <vector>

using namespace sdsl;
using namespace std;

int main(){
	unsigned char txt[31] = "shoptophotspothotsportstopshot";
	vector<int> txt2(15, 0);
	for(size_t i=0; i<15; ++i)
		txt2[i]=i%3;
	wavelet_tree<> wt1(txt, 30);
	wavelet_tree<> wt1_(wt1);
	wavelet_tree<vector<int> > wt2(txt2, 15);
	for(size_t i=0; i<=wt1.size(); ++i){
		cout << i << " : " << wt1.rank(i, 't') << " " << wt1.rank(i, 's') << " " << wt1.rank(i, 'o') << " " << wt1.rank(i, 'h') << " " << wt1.rank(i, 'p');
		if(i!=wt1.size())
			cout << " " << wt1[i] << " " << wt1_[i];
		cout << endl;
	}
	cout << wt1.select(1,'t') << endl;
	cout << wt1.select(2,'t') << endl;
	cout << wt1.select(3,'t') << endl;
	cout << util::get_size_in_bytes(wt1) << endl;

	size_t size3 = 10000;
	unsigned char txt3[size3+1];
	txt3[size3] = '\0';
	for(size_t i=0; i<size3; ++i) txt3[i] = 'a';
	wavelet_tree<> wt3(txt3, size3);
	wavelet_tree<> wt4(wt3);
	wt3.swap(wt4);
	cout << util::get_size_in_bytes(wt3) << " # size of wt3 in bytes " << endl;
	for(size_t i=0; i<wt3.size(); ++i){
		if( wt3[i] != txt3[i] ){
			cout<<" wt3["<<i<<"]="<<wt3[i]<<"!="<<txt3[i]<<"=txt3["<<i<<"]"<<endl;
			break;
		}
		if( wt3.rank(i+1, 'a') != i+1 ){
			cout<<"wt3.rank("<<i+1<<",'a')="<<wt3.rank(i+1,'a')<<"!="<<i+1<<endl;
			break;
		}
		if( wt3.select(i+1, 'a') != i ){
			cout<<"wt3.select("<<i+1<<",'a')="<<wt3.select(i+1,'a')<<"!="<<i<<endl;
			break;
		}
		if( wt3[i]!=wt4[i] or wt3.rank(i+1,'a')!=wt4.rank(i+1,'a') or wt3.select(i+1,'a')!=wt4.select(i+1,'a') ){
			cout<<"copy constructor does not work!"<<endl;
			break;
		}
	}
}
